"""This module defines Python-specific global parameters for DOLFIN by
adding to the global parameter set defined in C++."""

# Copyright (C) 2009-2016 Anders Logg
#
# This file is part of DOLFIN.
#
# DOLFIN is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# DOLFIN is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.

__all__ = ["parameters"]

from ffc import default_jit_parameters
from dolfin.cpp import parameters, Parameters

# Add form compiler parameters to global parameter set
if not parameters.has_parameter_set("form_compiler"):
    form_compiler_parameters = Parameters("form_compiler", **default_jit_parameters())
    parameters.add(form_compiler_parameters)
